#include <stdint.h>

#define maxDACValue 32

void setup()
{
  //DDRB and PORTB are constants built into the arduino software which control pins 8 through 13
  //Each bit corresponds to a single pin. The right-most (LSB) corresponds to pin 8, the uppermost two bits are unused
  
  //DDRB controls whether the pin is an input(zero) or output(one)
  DDRB = DDRB | B00011111;        //Make port B pins 0-4 outputs (i.e. digital pins 8-12)
  
  //PORTB used to set pins high (zero) or low (one) (if the pin is set to be an output)
  PORTB = PORTB & ~(B00011111);   //Set port B pins 0-4 to zero volts

  Serial.begin(9600);
}

void loop()
{
  //Variable used for counting in the for() loop
  //Can count up to 2^15-1 = 32767 or down to -1*2^15 = -32768
  static int16_t counter; //int16_t means "signed 16-bit integer type"

  //The for() loop counts from zero to 31
  for(counter = 0; counter < maxDACValue; counter += 1)
  {
    // "(PORTB & B11100000)" sets the lower 5 bits to zero while not effecting the upper 3 bits
    // "| counter" sets the lower 5 bits to the binary representation of the current counter value
    PORTB = (PORTB & B11100000) | counter;

    delay(1); //Pause for 1 ms
  }//End of for() loop
  
}


